using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.IO;
using System.IO.IsolatedStorage;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Serialization;

namespace MyEditor
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private IsolatedStorageFile isoFile;
		private EditorOptions options = null;
		private const string OptionsFileName = "MyEditor.config"; //"MyEditor.opt";

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// obtain isolated storage object for this user/assembly
			isoFile = IsolatedStorageFile.GetUserStoreForAssembly();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				isoFile.Close();
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBox1.Location = new System.Drawing.Point(0, 0);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(424, 177);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "The point is that there is no point, thereby rendering the entire conversation po" +
				"intless.";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			this.menuItem1.Text = "&File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "E&xit";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem4,
																					  this.menuItem5});
			this.menuItem3.Text = "&Options";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.Text = "&Background Color";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.Text = "&Text Color";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 177);
			this.Controls.Add(this.textBox1);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "MyEditor";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			options = new EditorOptions();
			options.BackColor = textBox1.BackColor;
			options.ForeColor = textBox1.ForeColor;
			try
			{
				// Load editor options from isolated storage and apply
				using (IsolatedStorageFileStream isoStream = 
						   new IsolatedStorageFileStream(
						   OptionsFileName, FileMode.Open, 
						   FileAccess.Read, isoFile))
				{
					/*
					BinaryFormatter formatter = new BinaryFormatter();
					options = (EditorOptions)formatter.Deserialize(
						isoStream);
					*/
					StreamReader reader = new StreamReader(isoStream);
					try
					{
						XmlSerializer ser = new XmlSerializer(typeof(EditorOptions));
						options = (EditorOptions)ser.Deserialize(isoStream);
					}
					finally
					{
						reader.Close();
					}

					textBox1.ForeColor = options.ForeColor;
					textBox1.BackColor = options.BackColor;
				}
			}
			catch (Exception ex)
			{
				// Ignore error loading.
				MessageBox.Show(this, ex.Message);
			}
			textBox1.AppendText(String.Format("\r\nMaximum size = {0}\r\n",
				isoFile.MaximumSize));
			textBox1.AppendText(String.Format("Current size = {0}\r\n",
				isoFile.CurrentSize));
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			// Save editor options to isolated storage
			try
			{
				using (IsolatedStorageFileStream isoStream =
						   new IsolatedStorageFileStream(
						   OptionsFileName, FileMode.OpenOrCreate, 
						   FileAccess.Write, isoFile))
				{
					/*
					BinaryFormatter formatter = 
						new BinaryFormatter();
					formatter.Serialize(isoStream, options);
					*/
					StreamWriter writer = new StreamWriter(isoStream);
					try
					{
						XmlSerializer ser = new XmlSerializer(typeof(EditorOptions));
						ser.Serialize(writer, options);
					}
					finally
					{
						writer.Close();
					}
				}
			}
			catch (Exception ex)
			{
				// ignore error writing
				MessageBox.Show(this, ex.Message);
			}
		}

		private Color EditColor(Color originalColor)
		{
			using (ColorDialog dlg = new ColorDialog())
			{
				dlg.Color = originalColor;
				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					return dlg.Color;
				}
				else
				{
					return originalColor;
				}
			}
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			options.BackColor = EditColor(options.BackColor);
			textBox1.BackColor = options.BackColor;
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			options.ForeColor = EditColor(options.ForeColor);
			textBox1.ForeColor = options.ForeColor;
		}
	}
}
